#include "StdAfx.h"
#include ".\cconsole.h"

CConsole::CConsole(void) {
	hConsoleIn	= GetStdHandle( STD_INPUT_HANDLE );
	hConsoleOut = GetStdHandle( STD_OUTPUT_HANDLE );
}

CConsole::~CConsole(void) {
	CloseHandle(hConsoleIn);
	CloseHandle(hConsoleOut);
}

BOOL CConsole::setColor(WORD wColor) {
	return SetConsoleTextAttribute(hConsoleOut, wColor);
}

BOOL CConsole::setCursor(SHORT x, SHORT y) {
	COORD co;
	co.X = x;
	co.Y = y;
	SetConsoleCursorPosition(hConsoleOut, co);
    return TRUE;
}

void CConsole::print(LPVOID charPointer, DWORD charSize) {
	DWORD	numberOfCharsWritten;
	WriteConsole(hConsoleOut,charPointer,charSize,&numberOfCharsWritten,NULL);
}

int CConsole::getInputChar() {
	int ch = getche();
	if (ch == 0x00 || ch == 0XE0) {
		ch = getche();
	}
	return ch;
}

void CConsole::waitInputKey() {
	int ch = getch();
	if (ch == 0xE0) {
		getch();
	}
}

void CConsole::cls() {
    COORD  coset;
    DWORD numberOfCharsWritten;
    WORD wAttribute;    

    CONSOLE_SCREEN_BUFFER_INFO cinf;
    GetConsoleScreenBufferInfo(hConsoleOut, &cinf);

    coset.X = 0;
    coset.Y = 0;
    wAttribute = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
    
    FillConsoleOutputCharacter(hConsoleOut, ' ', cinf.dwSize.X * cinf.dwSize.Y, coset, &numberOfCharsWritten);
    SetConsoleTextAttribute(hConsoleOut, wAttribute);
    FillConsoleOutputAttribute(hConsoleOut, wAttribute, cinf.dwSize.X * cinf.dwSize.Y, coset, &numberOfCharsWritten);
}

