#include "StdAfx.h"
#include ".\cmachine.h"

// wbhp[c
char headParts[][2][4] = {
	{" _ ",
	 "+o+"},
	{" _|",
	 "<o>"}
};
// {fBp[c
char bodyParts[][1][4] = {
	{"<H>"},
	{"=U="}
};
// CgA[p[c
char rightArmParts[][2][5] = {
	{" T^",
	 "[ "},
	{"`I^",
	 "[8 "}
};
// tgA[p[c
char leftArmParts[][2][4] = {
	{"^T ",
	 " E]"},
	{"^I ",
	 " 8]"}
};
// CgbOp[c
char rightLegParts[][2][5] = {
	{"  [I",
	 " |||"},
	{"  >I",
	 " ^^^"}
};
// tgbOp[c
char leftLegParts[][2][5] = {
	{"I]  ",
	 "||| "},
	{"I<  ",
	 "^^^ "}
};


CMachine::CMachine(void) {
	ZeroMemory(walk, sizeof(walk));
	ZeroMemory(parts, sizeof(parts));
	ZeroMemory(partsStatus, sizeof(partsStatus));
	setParts();
	energy = 100;
	energyCost = 1;
	gold = 0;
}

CMachine::~CMachine(void) {
}

void CMachine::setParts() {
	// 0:wbhp[c
	CopyMemory(head[0], headParts[parts[0]][0], 3);
	CopyMemory(head[1], headParts[parts[0]][1], 3);
	// 1:{fBp[c
	CopyMemory(body[0], bodyParts[parts[1]][0], 3);
	// 2:CgA[p[c
	CopyMemory(rightArm[0], rightArmParts[parts[2]][0], 3);
	CopyMemory(rightArm[1], rightArmParts[parts[2]][1], 3);
	// 3:tgA[p[c
	CopyMemory(leftArm[0], leftArmParts[parts[3]][0], 3);
	CopyMemory(leftArm[1], leftArmParts[parts[3]][1], 3);
	// 4:CgbOp[c
	CopyMemory(rightLeg[0], rightLegParts[parts[4]][0], 4);
	CopyMemory(rightLeg[1], rightLegParts[parts[4]][1], 4);
	// 5:tgbOp[c
	CopyMemory(leftLeg[0], leftLegParts[parts[5]][0], 4);
	CopyMemory(leftLeg[1], leftLegParts[parts[5]][1], 4);
}

void CMachine::setPartStatus (int partsID, int status) {
	partsStatus[partsID] = status;
	partsStatus[partsID] = (partsStatus[partsID] < 0) ? 0 : partsStatus[partsID];
	partsStatus[partsID] = (partsStatus[partsID] > 2) ? 2 : partsStatus[partsID];
}

WORD CMachine::getPartStatusColor (int partsID) {
	switch (partsStatus[partsID]) {
		case 1:// 
			// FOREGROUND_INTENSITY:8 | FOREGROUND_RED:4 | FOREGROUND_GREEN:2
			return 14;
		case 2:// j
			// FOREGROUND_INTENSITY:8 | FOREGROUND_RED:4
			return 12;
		default:
			// FOREGROUND_INTENSITY:8 | FOREGROUND_GREEN:2
			return 10;
	}
}
